package org.borutt.api.contact;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import org.borutt.validation.Email;

/**
 * Personal contact model within a phonebook. Contact is an entity identified
 * with a surrogate key, generated by the backing persistent repository. For a
 * simplification reason the same person entity serves multiple roles: JPA
 * entity, RESTful transfer object, view controller entity.
 */
@Entity
@Table(name = "Kontakt")
public class Contact implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(max = 100)
    private String name;

    @NotNull
    @Size(max = 100)
    private String surname;

    @Size(max = 255)
    private String address;

    @Pattern(regexp = "^$|\\+?\\d{3,13}")
    private String phone;

    @Pattern(regexp = "^$|\\+?\\d{3,13}")
    private String mobile;

    @Email(message = "{contact.email}")
    @Size(max = 100)
    private String email;

    @Column(columnDefinition = "TEXT")
    private String note;

    /**
     * Date of last change is automatically updated by database at the time of
     * record insert/update.
     */
    @Column(name = "changed", insertable = false, updatable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date changed;

    public Contact() {
    }

    public Contact(Contact other) {
        id = other.getId();
        name = other.getName();
        surname = other.getSurname();
        address = other.getAddress();
        phone = other.getPhone();
        mobile = other.getMobile();
        email = other.getEmail();
        note = other.getNote();
        changed = (other.getChanged() != null) ? (Date) other.getChanged().clone() : null;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    public Date getChanged() {
        return changed;
    }

    public void setChanged(Date changed) {
        this.changed = changed;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((id == null) ? 0 : id.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Contact other = (Contact) obj;
        if (id == null) {
            if (other.id != null)
                return false;
        } else if (!id.equals(other.id))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "Contact [id=" + id + ", name=" + name + ", surname=" + surname + ", address=" + address + ", phone="
                + phone + ", mobile=" + mobile + ", email=" + email + ", note=" + note + ", changed=" + changed + "]";
    }

}